%% VTEAM Model (Negative voltage perform OFF switching)
% Without window function !

function [v,i,x] = vteam_op_model(v_input,t_vec,x_init,iv)


%Fill parameters here
%-----------------------
Roff    = 
Ron     =
voff    = %Must be negative; 
von     = %Must be positive;
koff    =
kon     =
aoff    =
aon     =

D       = 
xoff    = 0;
xon     = D;
%-----------------------

i=zeros(length(t_vec),1);

v=v_input;
lambda=reallog(Ron/Roff);

for j=1:length(t_vec)
    if j==1
        x(j)=x_init;
        if iv==0
            i(j)=v(j)/(Roff+((Ron-Roff)/(xon-xoff))*(x(j)-xoff));
        elseif iv==1
            i(j)=v(j)/(Roff*exp(lambda*(x(j)-xoff)/(xon-xoff)));
        end
    else 
        dt=t_vec(j)-t_vec(j-1);
        if v(j)<=voff
            dxdt(j)=(koff*((v(j)/voff-1))^aoff);
            x(j)=x(j-1)+dxdt(j)*dt;
        elseif v(j)>=von
            dxdt(j)=(kon*((v(j)/von)-1)^aon);
            x(j)=x(j-1)+dxdt(j)*dt;
        else
            dxdt(j)=0;
            x(j)=x(j-1);
        end

        if (x(j)<0)
            x(j)=0;
            dxdt(j)=0;
        elseif (x(j) > D) 
            x(j)=D;
            dxdt(j)=0;
        end
    
        if iv==0
            i(j)=v(j)/(Roff+((Ron-Roff)/(xon-xoff))*(x(j)-xoff));
        elseif iv==1
            i(j)=v(j)/(Roff*exp(lambda*(x(j)-xoff)/(xon-xoff)));
        end
    end
end

end


